#include "../stdafx.h"
#include "TsStream.h"
#include "TsEpgMgr.h"

#define MAX_SHARE_EVENT	16

// EITϊBKvȃf[^͊Ƀobt@ɂƂOB
//   ppstProg 󂯎pf[^|C^ւ̃|C^
//   piCount 󂯎f[^(TSEPG_PROGRAMz̐AʏPLCxgꍇ͂Qȏ)
//   byTableID ZNVwb_Lڃe[uID
//   wServiceID ZNVwb_LڃT[rXID
//   pEitProgramTop Tsobt@擪
//
//   ߂l f[^͂Ɏgf[^AO̓G[
int CTsEPGMgr::TsEitParser(struct TSEPG_PROGRAM **ppstProg,int *piCount,BYTE byTableID,BYTE byVersion,WORD wServiceID,BYTE *pData)
{
	int i;
	
	struct TSEPG_PROGRAM stProg;
	ZeroMemory(&stProg,sizeof(struct TSEPG_PROGRAM));
	WORD wShareServiceID[MAX_SHARE_EVENT];
	WORD wShareEventID[MAX_SHARE_EVENT];
	BYTE byShareEventCount=0;

	if(byTableID==0x4E)
	{
		//  p/f
		stProg.byType = 1;
	}
	else if(byTableID==0x4F)
	{
		//  p/f(BS/CS)
		stProg.byType = 2;
	}
	else if(byTableID>=0x50 && byTableID<=0x57)
	{
		//  schedule
		stProg.byType = 3;
	}
	else if(byTableID>=0x60 && byTableID<=0x67)
	{
		//  schedule
		stProg.byType = 4;
	}
	stProg.byVersion = byVersion;

	// T[rXID/CxgID
	stProg.wServiceID = wServiceID;
	stProg.wEventID = (WORD)(pData[0])<<8 | pData[1];
	// 
	/*
	stProg.wStartMJD= (WORD)(pData[2])<<8 | pData[3];
	stProg.wEndMJD  = stProg.wStartMJD;
	stProg.dwStartTime = CTsStream::Convert_bcd_to_time(pData[4],pData[5],pData[6]);
	if(pData[7]==0xff && pData[8]==0xff && pData[9]==0xff)
	{
		stProg.dwDuration=0xffffffff;
		stProg.dwEndTime=0xffffffff;
	} else {
		stProg.dwDuration=CTsStream::Convert_bcd_to_time(pData[7],pData[8],pData[9]);
		stProg.dwEndTime=stProg.dwStartTime+stProg.dwDuration;
	}
	if(stProg.dwEndTime>=24*60*60)
	{
		stProg.wEndMJD++;
		stProg.dwEndTime-=24*60*60;
	}
	*/
	stProg.stStart.Date = (DWORD)(pData[2])<<8 | pData[3];
	stProg.stEnd.Date   = stProg.stStart.Date;
	stProg.stStart.Time = CDateTime::ConvertFrom_BcdTime(pData[4],pData[5],pData[6]);
	if(pData[7]==0xff && pData[8]==0xff && pData[9]==0xff)
	{
		// IԂ
		stProg.dwDuration=TimeVal_Unknown;
		stProg.stEnd.Time=TimeVal_Unknown;
	} else {
		// IԂݒ
		stProg.dwDuration=CDateTime::ConvertFrom_BcdTime(pData[7],pData[8],pData[9]);
		stProg.stEnd.Time=stProg.stStart.Time;
		CDateTime::OffsetDateTime(stProg.stEnd,stProg.dwDuration);
		// IԂQS𒴂ĂꍇA̓̓tɕϊ
		if(stProg.stEnd.Time>=TimeVal_OneDay)
		{
			stProg.stEnd.Date++;
			stProg.stEnd.Time-=TimeVal_OneDay;
		}
	}

	WORD wDescSize =(WORD)(pData[10]&0x0f)<<8 | pData[11];	
	for(i=0;i<wDescSize;)
	{
		BYTE byTag =pData[12+i];
		BYTE bySize=pData[12+i+1];					
		switch(byTag)
		{
		case 0x4d:
			{
				BYTE byTitleLen=pData[12+i+5];
				CTsStream::Convert_jpn_arib_char((char*)&pData[12+i+6],byTitleLen,stProg.szTitle,81);
				BYTE byTextLen=pData[12+i+6+byTitleLen];
				CTsStream::Convert_jpn_arib_char((char*)&pData[12+i+7+byTitleLen],byTextLen,stProg.szText,161);
			}
			break;
		case 0x50:
			{
				stProg.stComponent.byVideoType=pData[12+i+3];
			}
			break;
		case 0x54:
			{
			}
			break;
		case 0xc1:
			{
			}
			break;
		case 0xc4:
			{
				stProg.stComponent.byAudioType=pData[12+i+3];
			}
			break;
		case 0xd6:
			{
				BYTE byType = (pData[12+i+2]&0xf0)>>4;
				BYTE byCount= (pData[12+i+2]&0x0f);
				/*
				if(byType==0x01)
				{
					// LCxg
					byShareEventCount=min(byCount,MAX_SHARE_EVENT);
					for(j=0;j<byCount;j++)
					{
						wShareServiceID[j]=((WORD)pData[12+i+3+j*4])<<8|pData[12+i+4+j*4];
						wShareEventID[j]  =((WORD)pData[12+i+5+j*4])<<8|pData[12+i+6+j*4];
					}
				}
				*/
			}
			break;
		}
		i+=bySize+2;
	}

	if(byShareEventCount==0)
	{
		*ppstProg = new struct TSEPG_PROGRAM[1];
		if(!*ppstProg) return 0;
		(*ppstProg)[0] = stProg;
		*piCount = 1;
	} else {
		*ppstProg = new struct TSEPG_PROGRAM[byShareEventCount];
		if(!*ppstProg) return 0;
		for(i=0;i<byShareEventCount;i++)
		{
			(*ppstProg)[i] = stProg;
			(*ppstProg)[i].wServiceID = wShareServiceID[i];
			(*ppstProg)[i].wEventID   = wShareEventID[i];
		}
		*piCount = byShareEventCount;
	}
	return wDescSize+12;
}

// TsEitParser Ŋmۂ̊J
void CTsEPGMgr::FreeTsEitParserMemory(struct TSEPG_PROGRAM *pstProg,int iCount)
{
	int i;
	for(i=0;i<iCount;i++)
	{
		// Imۃ̊J
	}
	delete []pstProg;
}


#ifdef TSEITPARSER_DEBUG_PRINT
void CTsEPGMgr::TsEitParser_DebugPrintProgram(BOOL bActual,struct TS_section_header &stSecHeader,struct TSEPG_PROGRAM &stProg)
{
	char dbg_buf[500];
	long dbg_y,dbg_mo,dbg_d;
	long dbg_y2,dbg_mo2,dbg_d2;
	long dbg_h,dbg_mn,dbg_s;
	long dbg_h2,dbg_mn2,dbg_s2;
	/*
	dbg_h=stProg.dwStartTime/60/60;
	dbg_mn=(stProg.dwStartTime-dbg_h*60*60)/60;
	dbg_s=(stProg.dwStartTime-dbg_h*60*60-dbg_mn*60);
	dbg_h2=stProg.dwEndTime/60/60;
	dbg_mn2=(stProg.dwEndTime-dbg_h2*60*60)/60;
	dbg_s2=(stProg.dwEndTime-dbg_h2*60*60-dbg_mn2*60);
	*/

	CDateTime::ConvertFrom_MJD(stProg.stStart.Date,dbg_y,dbg_mo,dbg_d);
	CDateTime::ConvertFrom_MJD(stProg.stEnd.Date,dbg_y2,dbg_mo2,dbg_d2);
	CDateTime::ConvertFrom_TimeSec(stProg.stStart.Time,dbg_h,dbg_mn,dbg_s);
	CDateTime::ConvertFrom_TimeSec(stProg.stEnd.Time,dbg_h2,dbg_mn2,dbg_s2);

	SYSTEMTIME stTime;
	GetLocalTime(&stTime);
	/*
	CTsStream::Convert_mjd_to_date(stProg.wStartMJD,&dbg_y,&dbg_mo,&dbg_d);
	CTsStream::Convert_mjd_to_date(stProg.wEndMJD,&dbg_y2,&dbg_mo2,&dbg_d2);
	*/
	wsprintf(dbg_buf,"%c EIT %02d:%02d:%02d>",bActual?'*':' ',stTime.wHour,stTime.wMinute,stTime.wSecond);
	OutputDebugString(dbg_buf);
	wsprintf(dbg_buf,"0x%02X(Sec:%X,ver:%X) %d %04X %4d/%2d/%2d %02d:%02d:%02d - %4d/%2d/%2d %02d:%02d:%02d \n",		
		stSecHeader.table_id,
		stSecHeader.section_number,
		stSecHeader.version_number,
		stProg.wServiceID,
		stProg.wEventID,
		dbg_y,dbg_mo,dbg_d,
		dbg_h,dbg_mn,dbg_s,
		dbg_y2,dbg_mo2,dbg_d2,
		dbg_h2,dbg_mn2,dbg_s2);
	OutputDebugString(dbg_buf);
	wsprintf(dbg_buf,"\t\"%s\"\n\t\"%s\"\n",stProg.szTitle,stProg.szText);
	OutputDebugString(dbg_buf);
}
#endif